# Intrinio API
#
# Welcome to the Intrinio API! Through our Financial Data Marketplace, we offer a wide selection of financial data feed APIs sourced by our own proprietary processes as well as from many data vendors. For a complete API request / response reference please view the [Intrinio API documentation](https://intrinio.com/documentation/api_v2). If you need additional help in using the API, please visit the [Intrinio website](https://intrinio.com) and click on the chat icon in the lower right corner.
#
# OpenAPI spec version: 2.8.4
# 
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' ApiResponseCryptoExchanges Class
#'
#' @field exchanges 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
ApiResponseCryptoExchanges <- R6::R6Class(
  'ApiResponseCryptoExchanges',
  public = list(
    `exchanges` = NA,
    `exchanges_data_frame` = NULL,
    initialize = function(`exchanges`){
      if (!missing(`exchanges`)) {
        self$`exchanges` <- `exchanges`
      }
    },
    toJSON = function() {
      ApiResponseCryptoExchangesObject <- list()
      if (!is.null(self$`exchanges`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`exchanges`) && ((length(self$`exchanges`) == 0) || ((length(self$`exchanges`) != 0 && R6::is.R6(self$`exchanges`[[1]]))))) {
          ApiResponseCryptoExchangesObject[['exchanges']] <- lapply(self$`exchanges`, function(x) x$toJSON())
        } else {
          ApiResponseCryptoExchangesObject[['exchanges']] <- jsonlite::toJSON(self$`exchanges`, auto_unbox = TRUE)
        }
      }

      ApiResponseCryptoExchangesObject
    },
    fromJSON = function(ApiResponseCryptoExchangesJson) {
      ApiResponseCryptoExchangesObject <- jsonlite::fromJSON(ApiResponseCryptoExchangesJson)
      if (!is.null(ApiResponseCryptoExchangesObject$`exchanges`)) {
        self$`exchanges` <- ApiResponseCryptoExchangesObject$`exchanges`
      }
    },
    toJSONString = function() {
      jsonlite::toJSON(self$toJSON(), auto_unbox = TRUE, pretty = TRUE)
    },
    fromJSONString = function(ApiResponseCryptoExchangesJson) {
      ApiResponseCryptoExchangesObject <- jsonlite::fromJSON(ApiResponseCryptoExchangesJson, simplifyDataFrame = FALSE)
      self$setFromList(ApiResponseCryptoExchangesObject)
    },
    setFromList = function(listObject) {


      self$`exchanges` <- lapply(listObject$`exchanges`, function(x) {
      CryptoExchangeObject <- CryptoExchange$new()
      CryptoExchangeObject$setFromList(x)
      return(CryptoExchangeObject)
      })

      exchanges_list <- lapply(self$`exchanges`, function(x) {
        return(x$getAsList()) 
      })

      self$`exchanges_data_frame` <- do.call(rbind, lapply(exchanges_list, data.frame))






    },
    getAsList = function() {
      listObject = list()
      listObject[["exchanges"]] <- lapply(self$`exchanges`, function(o) {
        return(o$getAsList())
      })




        
      return(listObject)
    }
  )
)
