# Intrinio API
#
# Welcome to the Intrinio API! Through our Financial Data Marketplace, we offer a wide selection of financial data feed APIs sourced by our own proprietary processes as well as from many data vendors. For a complete API request / response reference please view the [Intrinio API documentation](https://intrinio.com/documentation/api_v2). If you need additional help in using the API, please visit the [Intrinio website](https://intrinio.com) and click on the chat icon in the lower right corner.
#
# OpenAPI spec version: 2.8.4
# 
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' ApiResponseCryptoPairs Class
#'
#' @field pairs 
#' @field next_page 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
ApiResponseCryptoPairs <- R6::R6Class(
  'ApiResponseCryptoPairs',
  public = list(
    `pairs` = NA,
    `pairs_data_frame` = NULL,
    `next_page` = NA,
    initialize = function(`pairs`, `next_page`){
      if (!missing(`pairs`)) {
        self$`pairs` <- `pairs`
      }
      if (!missing(`next_page`)) {
        self$`next_page` <- `next_page`
      }
    },
    toJSON = function() {
      ApiResponseCryptoPairsObject <- list()
      if (!is.null(self$`pairs`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`pairs`) && ((length(self$`pairs`) == 0) || ((length(self$`pairs`) != 0 && R6::is.R6(self$`pairs`[[1]]))))) {
          ApiResponseCryptoPairsObject[['pairs']] <- lapply(self$`pairs`, function(x) x$toJSON())
        } else {
          ApiResponseCryptoPairsObject[['pairs']] <- jsonlite::toJSON(self$`pairs`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`next_page`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`next_page`) && ((length(self$`next_page`) == 0) || ((length(self$`next_page`) != 0 && R6::is.R6(self$`next_page`[[1]]))))) {
          ApiResponseCryptoPairsObject[['next_page']] <- lapply(self$`next_page`, function(x) x$toJSON())
        } else {
          ApiResponseCryptoPairsObject[['next_page']] <- jsonlite::toJSON(self$`next_page`, auto_unbox = TRUE)
        }
      }

      ApiResponseCryptoPairsObject
    },
    fromJSON = function(ApiResponseCryptoPairsJson) {
      ApiResponseCryptoPairsObject <- jsonlite::fromJSON(ApiResponseCryptoPairsJson)
      if (!is.null(ApiResponseCryptoPairsObject$`pairs`)) {
        self$`pairs` <- ApiResponseCryptoPairsObject$`pairs`
      }
      if (!is.null(ApiResponseCryptoPairsObject$`next_page`)) {
        self$`next_page` <- ApiResponseCryptoPairsObject$`next_page`
      }
    },
    toJSONString = function() {
      jsonlite::toJSON(self$toJSON(), auto_unbox = TRUE, pretty = TRUE)
    },
    fromJSONString = function(ApiResponseCryptoPairsJson) {
      ApiResponseCryptoPairsObject <- jsonlite::fromJSON(ApiResponseCryptoPairsJson, simplifyDataFrame = FALSE)
      self$setFromList(ApiResponseCryptoPairsObject)
    },
    setFromList = function(listObject) {


      self$`pairs` <- lapply(listObject$`pairs`, function(x) {
      CryptoPairObject <- CryptoPair$new()
      CryptoPairObject$setFromList(x)
      return(CryptoPairObject)
      })

      pairs_list <- lapply(self$`pairs`, function(x) {
        return(x$getAsList()) 
      })

      self$`pairs_data_frame` <- do.call(rbind, lapply(pairs_list, data.frame))






      if (!is.null(listObject$`next_page`)) {
        self$`next_page` <- listObject$`next_page`
      }
      else {
        self$`next_page` <- NA 
      }

    },
    getAsList = function() {
      listObject = list()
      listObject[["pairs"]] <- lapply(self$`pairs`, function(o) {
        return(o$getAsList())
      })




        
      listObject[["next_page"]] <- self$`next_page`
      return(listObject)
    }
  )
)
