# Intrinio API
#
# Welcome to the Intrinio API! Through our Financial Data Marketplace, we offer a wide selection of financial data feed APIs sourced by our own proprietary processes as well as from many data vendors. For a complete API request / response reference please view the [Intrinio API documentation](https://intrinio.com/documentation/api_v2). If you need additional help in using the API, please visit the [Intrinio website](https://intrinio.com) and click on the chat icon in the lower right corner.
#
# OpenAPI spec version: 2.8.4
# 
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' ApiResponseCryptoStats Class
#'
#' @field stats 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
ApiResponseCryptoStats <- R6::R6Class(
  'ApiResponseCryptoStats',
  public = list(
    `stats` = NA,
    `stats_data_frame` = NULL,
    initialize = function(`stats`){
      if (!missing(`stats`)) {
        self$`stats` <- `stats`
      }
    },
    toJSON = function() {
      ApiResponseCryptoStatsObject <- list()
      if (!is.null(self$`stats`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`stats`) && ((length(self$`stats`) == 0) || ((length(self$`stats`) != 0 && R6::is.R6(self$`stats`[[1]]))))) {
          ApiResponseCryptoStatsObject[['stats']] <- lapply(self$`stats`, function(x) x$toJSON())
        } else {
          ApiResponseCryptoStatsObject[['stats']] <- jsonlite::toJSON(self$`stats`, auto_unbox = TRUE)
        }
      }

      ApiResponseCryptoStatsObject
    },
    fromJSON = function(ApiResponseCryptoStatsJson) {
      ApiResponseCryptoStatsObject <- jsonlite::fromJSON(ApiResponseCryptoStatsJson)
      if (!is.null(ApiResponseCryptoStatsObject$`stats`)) {
        self$`stats` <- ApiResponseCryptoStatsObject$`stats`
      }
    },
    toJSONString = function() {
      jsonlite::toJSON(self$toJSON(), auto_unbox = TRUE, pretty = TRUE)
    },
    fromJSONString = function(ApiResponseCryptoStatsJson) {
      ApiResponseCryptoStatsObject <- jsonlite::fromJSON(ApiResponseCryptoStatsJson, simplifyDataFrame = FALSE)
      self$setFromList(ApiResponseCryptoStatsObject)
    },
    setFromList = function(listObject) {


      self$`stats` <- lapply(listObject$`stats`, function(x) {
      CryptoStatObject <- CryptoStat$new()
      CryptoStatObject$setFromList(x)
      return(CryptoStatObject)
      })

      stats_list <- lapply(self$`stats`, function(x) {
        return(x$getAsList()) 
      })

      self$`stats_data_frame` <- do.call(rbind, lapply(stats_list, data.frame))






    },
    getAsList = function() {
      listObject = list()
      listObject[["stats"]] <- lapply(self$`stats`, function(o) {
        return(o$getAsList())
      })




        
      return(listObject)
    }
  )
)
