# Intrinio API
#
# Welcome to the Intrinio API! Through our Financial Data Marketplace, we offer a wide selection of financial data feed APIs sourced by our own proprietary processes as well as from many data vendors. For a complete API request / response reference please view the [Intrinio API documentation](https://intrinio.com/documentation/api_v2). If you need additional help in using the API, please visit the [Intrinio website](https://intrinio.com) and click on the chat icon in the lower right corner.
#
# OpenAPI spec version: 2.8.4
# 
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' CryptoBookEntry Class
#'
#' @field price 
#' @field size 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
CryptoBookEntry <- R6::R6Class(
  'CryptoBookEntry',
  public = list(
    `price` = NA,
    `size` = NA,
    initialize = function(`price`, `size`){
      if (!missing(`price`)) {
        self$`price` <- `price`
      }
      if (!missing(`size`)) {
        self$`size` <- `size`
      }
    },
    toJSON = function() {
      CryptoBookEntryObject <- list()
      if (!is.null(self$`price`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`price`) && ((length(self$`price`) == 0) || ((length(self$`price`) != 0 && R6::is.R6(self$`price`[[1]]))))) {
          CryptoBookEntryObject[['price']] <- lapply(self$`price`, function(x) x$toJSON())
        } else {
          CryptoBookEntryObject[['price']] <- jsonlite::toJSON(self$`price`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`size`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`size`) && ((length(self$`size`) == 0) || ((length(self$`size`) != 0 && R6::is.R6(self$`size`[[1]]))))) {
          CryptoBookEntryObject[['size']] <- lapply(self$`size`, function(x) x$toJSON())
        } else {
          CryptoBookEntryObject[['size']] <- jsonlite::toJSON(self$`size`, auto_unbox = TRUE)
        }
      }

      CryptoBookEntryObject
    },
    fromJSON = function(CryptoBookEntryJson) {
      CryptoBookEntryObject <- jsonlite::fromJSON(CryptoBookEntryJson)
      if (!is.null(CryptoBookEntryObject$`price`)) {
        self$`price` <- CryptoBookEntryObject$`price`
      }
      if (!is.null(CryptoBookEntryObject$`size`)) {
        self$`size` <- CryptoBookEntryObject$`size`
      }
    },
    toJSONString = function() {
      jsonlite::toJSON(self$toJSON(), auto_unbox = TRUE, pretty = TRUE)
    },
    fromJSONString = function(CryptoBookEntryJson) {
      CryptoBookEntryObject <- jsonlite::fromJSON(CryptoBookEntryJson, simplifyDataFrame = FALSE)
      self$setFromList(CryptoBookEntryObject)
    },
    setFromList = function(listObject) {
      if (!is.null(listObject$`price`)) {
        self$`price` <- listObject$`price`
      }
      else {
        self$`price` <- NA 
      }

      if (!is.null(listObject$`size`)) {
        self$`size` <- listObject$`size`
      }
      else {
        self$`size` <- NA 
      }

    },
    getAsList = function() {
      listObject = list()
      listObject[["price"]] <- self$`price`
      listObject[["size"]] <- self$`size`
      return(listObject)
    }
  )
)
