# Intrinio API
#
# Welcome to the Intrinio API! Through our Financial Data Marketplace, we offer a wide selection of financial data feed APIs sourced by our own proprietary processes as well as from many data vendors. For a complete API request / response reference please view the [Intrinio API documentation](https://intrinio.com/documentation/api_v2). If you need additional help in using the API, please visit the [Intrinio website](https://intrinio.com) and click on the chat icon in the lower right corner.
#
# OpenAPI spec version: 2.8.4
# 
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' CryptoCurrency Class
#'
#' @field name 
#' @field code 
#' @field symbol 
#' @field first_price_date 
#' @field last_price_date 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
CryptoCurrency <- R6::R6Class(
  'CryptoCurrency',
  public = list(
    `name` = NA,
    `code` = NA,
    `symbol` = NA,
    `first_price_date` = NA,
    `last_price_date` = NA,
    initialize = function(`name`, `code`, `symbol`, `first_price_date`, `last_price_date`){
      if (!missing(`name`)) {
        self$`name` <- `name`
      }
      if (!missing(`code`)) {
        self$`code` <- `code`
      }
      if (!missing(`symbol`)) {
        self$`symbol` <- `symbol`
      }
      if (!missing(`first_price_date`)) {
        self$`first_price_date` <- `first_price_date`
      }
      if (!missing(`last_price_date`)) {
        self$`last_price_date` <- `last_price_date`
      }
    },
    toJSON = function() {
      CryptoCurrencyObject <- list()
      if (!is.null(self$`name`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`name`) && ((length(self$`name`) == 0) || ((length(self$`name`) != 0 && R6::is.R6(self$`name`[[1]]))))) {
          CryptoCurrencyObject[['name']] <- lapply(self$`name`, function(x) x$toJSON())
        } else {
          CryptoCurrencyObject[['name']] <- jsonlite::toJSON(self$`name`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`code`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`code`) && ((length(self$`code`) == 0) || ((length(self$`code`) != 0 && R6::is.R6(self$`code`[[1]]))))) {
          CryptoCurrencyObject[['code']] <- lapply(self$`code`, function(x) x$toJSON())
        } else {
          CryptoCurrencyObject[['code']] <- jsonlite::toJSON(self$`code`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`symbol`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`symbol`) && ((length(self$`symbol`) == 0) || ((length(self$`symbol`) != 0 && R6::is.R6(self$`symbol`[[1]]))))) {
          CryptoCurrencyObject[['symbol']] <- lapply(self$`symbol`, function(x) x$toJSON())
        } else {
          CryptoCurrencyObject[['symbol']] <- jsonlite::toJSON(self$`symbol`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`first_price_date`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`first_price_date`) && ((length(self$`first_price_date`) == 0) || ((length(self$`first_price_date`) != 0 && R6::is.R6(self$`first_price_date`[[1]]))))) {
          CryptoCurrencyObject[['first_price_date']] <- lapply(self$`first_price_date`, function(x) x$toJSON())
        } else {
          CryptoCurrencyObject[['first_price_date']] <- jsonlite::toJSON(self$`first_price_date`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`last_price_date`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`last_price_date`) && ((length(self$`last_price_date`) == 0) || ((length(self$`last_price_date`) != 0 && R6::is.R6(self$`last_price_date`[[1]]))))) {
          CryptoCurrencyObject[['last_price_date']] <- lapply(self$`last_price_date`, function(x) x$toJSON())
        } else {
          CryptoCurrencyObject[['last_price_date']] <- jsonlite::toJSON(self$`last_price_date`, auto_unbox = TRUE)
        }
      }

      CryptoCurrencyObject
    },
    fromJSON = function(CryptoCurrencyJson) {
      CryptoCurrencyObject <- jsonlite::fromJSON(CryptoCurrencyJson)
      if (!is.null(CryptoCurrencyObject$`name`)) {
        self$`name` <- CryptoCurrencyObject$`name`
      }
      if (!is.null(CryptoCurrencyObject$`code`)) {
        self$`code` <- CryptoCurrencyObject$`code`
      }
      if (!is.null(CryptoCurrencyObject$`symbol`)) {
        self$`symbol` <- CryptoCurrencyObject$`symbol`
      }
      if (!is.null(CryptoCurrencyObject$`first_price_date`)) {
        self$`first_price_date` <- CryptoCurrencyObject$`first_price_date`
      }
      if (!is.null(CryptoCurrencyObject$`last_price_date`)) {
        self$`last_price_date` <- CryptoCurrencyObject$`last_price_date`
      }
    },
    toJSONString = function() {
      jsonlite::toJSON(self$toJSON(), auto_unbox = TRUE, pretty = TRUE)
    },
    fromJSONString = function(CryptoCurrencyJson) {
      CryptoCurrencyObject <- jsonlite::fromJSON(CryptoCurrencyJson, simplifyDataFrame = FALSE)
      self$setFromList(CryptoCurrencyObject)
    },
    setFromList = function(listObject) {
      if (!is.null(listObject$`name`)) {
        self$`name` <- listObject$`name`
      }
      else {
        self$`name` <- NA 
      }

      if (!is.null(listObject$`code`)) {
        self$`code` <- listObject$`code`
      }
      else {
        self$`code` <- NA 
      }

      if (!is.null(listObject$`symbol`)) {
        self$`symbol` <- listObject$`symbol`
      }
      else {
        self$`symbol` <- NA 
      }

      if (!is.null(listObject$`first_price_date`)) {
        self$`first_price_date` <- listObject$`first_price_date`
      }
      else {
        self$`first_price_date` <- NA 
      }

      if (!is.null(listObject$`last_price_date`)) {
        self$`last_price_date` <- listObject$`last_price_date`
      }
      else {
        self$`last_price_date` <- NA 
      }

    },
    getAsList = function() {
      listObject = list()
      listObject[["name"]] <- self$`name`
      listObject[["code"]] <- self$`code`
      listObject[["symbol"]] <- self$`symbol`
      listObject[["first_price_date"]] <- self$`first_price_date`
      listObject[["last_price_date"]] <- self$`last_price_date`
      return(listObject)
    }
  )
)
