# Intrinio API
#
# Welcome to the Intrinio API! Through our Financial Data Marketplace, we offer a wide selection of financial data feed APIs sourced by our own proprietary processes as well as from many data vendors. For a complete API request / response reference please view the [Intrinio API documentation](https://intrinio.com/documentation/api_v2). If you need additional help in using the API, please visit the [Intrinio website](https://intrinio.com) and click on the chat icon in the lower right corner.
#
# OpenAPI spec version: 2.8.4
# 
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' CryptoPair Class
#'
#' @field name 
#' @field code 
#' @field first_price_date 
#' @field last_price_date 
#' @field book_depth_available 
#' @field history_available 
#' @field snapshot_available 
#' @field trades_available 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
CryptoPair <- R6::R6Class(
  'CryptoPair',
  public = list(
    `name` = NA,
    `code` = NA,
    `first_price_date` = NA,
    `last_price_date` = NA,
    `book_depth_available` = NA,
    `history_available` = NA,
    `snapshot_available` = NA,
    `trades_available` = NA,
    initialize = function(`name`, `code`, `first_price_date`, `last_price_date`, `book_depth_available`, `history_available`, `snapshot_available`, `trades_available`){
      if (!missing(`name`)) {
        self$`name` <- `name`
      }
      if (!missing(`code`)) {
        self$`code` <- `code`
      }
      if (!missing(`first_price_date`)) {
        self$`first_price_date` <- `first_price_date`
      }
      if (!missing(`last_price_date`)) {
        self$`last_price_date` <- `last_price_date`
      }
      if (!missing(`book_depth_available`)) {
        self$`book_depth_available` <- `book_depth_available`
      }
      if (!missing(`history_available`)) {
        self$`history_available` <- `history_available`
      }
      if (!missing(`snapshot_available`)) {
        self$`snapshot_available` <- `snapshot_available`
      }
      if (!missing(`trades_available`)) {
        self$`trades_available` <- `trades_available`
      }
    },
    toJSON = function() {
      CryptoPairObject <- list()
      if (!is.null(self$`name`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`name`) && ((length(self$`name`) == 0) || ((length(self$`name`) != 0 && R6::is.R6(self$`name`[[1]]))))) {
          CryptoPairObject[['name']] <- lapply(self$`name`, function(x) x$toJSON())
        } else {
          CryptoPairObject[['name']] <- jsonlite::toJSON(self$`name`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`code`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`code`) && ((length(self$`code`) == 0) || ((length(self$`code`) != 0 && R6::is.R6(self$`code`[[1]]))))) {
          CryptoPairObject[['code']] <- lapply(self$`code`, function(x) x$toJSON())
        } else {
          CryptoPairObject[['code']] <- jsonlite::toJSON(self$`code`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`first_price_date`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`first_price_date`) && ((length(self$`first_price_date`) == 0) || ((length(self$`first_price_date`) != 0 && R6::is.R6(self$`first_price_date`[[1]]))))) {
          CryptoPairObject[['first_price_date']] <- lapply(self$`first_price_date`, function(x) x$toJSON())
        } else {
          CryptoPairObject[['first_price_date']] <- jsonlite::toJSON(self$`first_price_date`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`last_price_date`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`last_price_date`) && ((length(self$`last_price_date`) == 0) || ((length(self$`last_price_date`) != 0 && R6::is.R6(self$`last_price_date`[[1]]))))) {
          CryptoPairObject[['last_price_date']] <- lapply(self$`last_price_date`, function(x) x$toJSON())
        } else {
          CryptoPairObject[['last_price_date']] <- jsonlite::toJSON(self$`last_price_date`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`book_depth_available`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`book_depth_available`) && ((length(self$`book_depth_available`) == 0) || ((length(self$`book_depth_available`) != 0 && R6::is.R6(self$`book_depth_available`[[1]]))))) {
          CryptoPairObject[['book_depth_available']] <- lapply(self$`book_depth_available`, function(x) x$toJSON())
        } else {
          CryptoPairObject[['book_depth_available']] <- jsonlite::toJSON(self$`book_depth_available`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`history_available`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`history_available`) && ((length(self$`history_available`) == 0) || ((length(self$`history_available`) != 0 && R6::is.R6(self$`history_available`[[1]]))))) {
          CryptoPairObject[['history_available']] <- lapply(self$`history_available`, function(x) x$toJSON())
        } else {
          CryptoPairObject[['history_available']] <- jsonlite::toJSON(self$`history_available`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`snapshot_available`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`snapshot_available`) && ((length(self$`snapshot_available`) == 0) || ((length(self$`snapshot_available`) != 0 && R6::is.R6(self$`snapshot_available`[[1]]))))) {
          CryptoPairObject[['snapshot_available']] <- lapply(self$`snapshot_available`, function(x) x$toJSON())
        } else {
          CryptoPairObject[['snapshot_available']] <- jsonlite::toJSON(self$`snapshot_available`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`trades_available`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`trades_available`) && ((length(self$`trades_available`) == 0) || ((length(self$`trades_available`) != 0 && R6::is.R6(self$`trades_available`[[1]]))))) {
          CryptoPairObject[['trades_available']] <- lapply(self$`trades_available`, function(x) x$toJSON())
        } else {
          CryptoPairObject[['trades_available']] <- jsonlite::toJSON(self$`trades_available`, auto_unbox = TRUE)
        }
      }

      CryptoPairObject
    },
    fromJSON = function(CryptoPairJson) {
      CryptoPairObject <- jsonlite::fromJSON(CryptoPairJson)
      if (!is.null(CryptoPairObject$`name`)) {
        self$`name` <- CryptoPairObject$`name`
      }
      if (!is.null(CryptoPairObject$`code`)) {
        self$`code` <- CryptoPairObject$`code`
      }
      if (!is.null(CryptoPairObject$`first_price_date`)) {
        self$`first_price_date` <- CryptoPairObject$`first_price_date`
      }
      if (!is.null(CryptoPairObject$`last_price_date`)) {
        self$`last_price_date` <- CryptoPairObject$`last_price_date`
      }
      if (!is.null(CryptoPairObject$`book_depth_available`)) {
        self$`book_depth_available` <- CryptoPairObject$`book_depth_available`
      }
      if (!is.null(CryptoPairObject$`history_available`)) {
        self$`history_available` <- CryptoPairObject$`history_available`
      }
      if (!is.null(CryptoPairObject$`snapshot_available`)) {
        self$`snapshot_available` <- CryptoPairObject$`snapshot_available`
      }
      if (!is.null(CryptoPairObject$`trades_available`)) {
        self$`trades_available` <- CryptoPairObject$`trades_available`
      }
    },
    toJSONString = function() {
      jsonlite::toJSON(self$toJSON(), auto_unbox = TRUE, pretty = TRUE)
    },
    fromJSONString = function(CryptoPairJson) {
      CryptoPairObject <- jsonlite::fromJSON(CryptoPairJson, simplifyDataFrame = FALSE)
      self$setFromList(CryptoPairObject)
    },
    setFromList = function(listObject) {
      if (!is.null(listObject$`name`)) {
        self$`name` <- listObject$`name`
      }
      else {
        self$`name` <- NA 
      }

      if (!is.null(listObject$`code`)) {
        self$`code` <- listObject$`code`
      }
      else {
        self$`code` <- NA 
      }

      if (!is.null(listObject$`first_price_date`)) {
        self$`first_price_date` <- listObject$`first_price_date`
      }
      else {
        self$`first_price_date` <- NA 
      }

      if (!is.null(listObject$`last_price_date`)) {
        self$`last_price_date` <- listObject$`last_price_date`
      }
      else {
        self$`last_price_date` <- NA 
      }






      if (!is.null(listObject$`book_depth_available`)) {
        self$`book_depth_available` <- listObject$`book_depth_available`
      }
      else {
        self$`book_depth_available` <- NA
      }








      if (!is.null(listObject$`history_available`)) {
        self$`history_available` <- listObject$`history_available`
      }
      else {
        self$`history_available` <- NA
      }








      if (!is.null(listObject$`snapshot_available`)) {
        self$`snapshot_available` <- listObject$`snapshot_available`
      }
      else {
        self$`snapshot_available` <- NA
      }








      if (!is.null(listObject$`trades_available`)) {
        self$`trades_available` <- listObject$`trades_available`
      }
      else {
        self$`trades_available` <- NA
      }



    },
    getAsList = function() {
      listObject = list()
      listObject[["name"]] <- self$`name`
      listObject[["code"]] <- self$`code`
      listObject[["first_price_date"]] <- self$`first_price_date`
      listObject[["last_price_date"]] <- self$`last_price_date`



      listObject[["book_depth_available"]] <- self$`book_depth_available`

        



      listObject[["history_available"]] <- self$`history_available`

        



      listObject[["snapshot_available"]] <- self$`snapshot_available`

        



      listObject[["trades_available"]] <- self$`trades_available`

        
      return(listObject)
    }
  )
)
