# Intrinio API
#
# Welcome to the Intrinio API! Through our Financial Data Marketplace, we offer a wide selection of financial data feed APIs sourced by our own proprietary processes as well as from many data vendors. For a complete API request / response reference please view the [Intrinio API documentation](https://intrinio.com/documentation/api_v2). If you need additional help in using the API, please visit the [Intrinio website](https://intrinio.com) and click on the chat icon in the lower right corner.
#
# OpenAPI spec version: 2.8.4
# 
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' CryptoStat Class
#'
#' @field name 
#' @field code 
#' @field symbol 
#' @field market_cap_usd 
#' @field available_supply 
#' @field total_supply 
#' @field max_supply 
#' @field last_updated 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
CryptoStat <- R6::R6Class(
  'CryptoStat',
  public = list(
    `name` = NA,
    `code` = NA,
    `symbol` = NA,
    `market_cap_usd` = NA,
    `available_supply` = NA,
    `total_supply` = NA,
    `max_supply` = NA,
    `last_updated` = NA,
    initialize = function(`name`, `code`, `symbol`, `market_cap_usd`, `available_supply`, `total_supply`, `max_supply`, `last_updated`){
      if (!missing(`name`)) {
        self$`name` <- `name`
      }
      if (!missing(`code`)) {
        self$`code` <- `code`
      }
      if (!missing(`symbol`)) {
        self$`symbol` <- `symbol`
      }
      if (!missing(`market_cap_usd`)) {
        self$`market_cap_usd` <- `market_cap_usd`
      }
      if (!missing(`available_supply`)) {
        self$`available_supply` <- `available_supply`
      }
      if (!missing(`total_supply`)) {
        self$`total_supply` <- `total_supply`
      }
      if (!missing(`max_supply`)) {
        self$`max_supply` <- `max_supply`
      }
      if (!missing(`last_updated`)) {
        self$`last_updated` <- `last_updated`
      }
    },
    toJSON = function() {
      CryptoStatObject <- list()
      if (!is.null(self$`name`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`name`) && ((length(self$`name`) == 0) || ((length(self$`name`) != 0 && R6::is.R6(self$`name`[[1]]))))) {
          CryptoStatObject[['name']] <- lapply(self$`name`, function(x) x$toJSON())
        } else {
          CryptoStatObject[['name']] <- jsonlite::toJSON(self$`name`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`code`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`code`) && ((length(self$`code`) == 0) || ((length(self$`code`) != 0 && R6::is.R6(self$`code`[[1]]))))) {
          CryptoStatObject[['code']] <- lapply(self$`code`, function(x) x$toJSON())
        } else {
          CryptoStatObject[['code']] <- jsonlite::toJSON(self$`code`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`symbol`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`symbol`) && ((length(self$`symbol`) == 0) || ((length(self$`symbol`) != 0 && R6::is.R6(self$`symbol`[[1]]))))) {
          CryptoStatObject[['symbol']] <- lapply(self$`symbol`, function(x) x$toJSON())
        } else {
          CryptoStatObject[['symbol']] <- jsonlite::toJSON(self$`symbol`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`market_cap_usd`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`market_cap_usd`) && ((length(self$`market_cap_usd`) == 0) || ((length(self$`market_cap_usd`) != 0 && R6::is.R6(self$`market_cap_usd`[[1]]))))) {
          CryptoStatObject[['market_cap_usd']] <- lapply(self$`market_cap_usd`, function(x) x$toJSON())
        } else {
          CryptoStatObject[['market_cap_usd']] <- jsonlite::toJSON(self$`market_cap_usd`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`available_supply`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`available_supply`) && ((length(self$`available_supply`) == 0) || ((length(self$`available_supply`) != 0 && R6::is.R6(self$`available_supply`[[1]]))))) {
          CryptoStatObject[['available_supply']] <- lapply(self$`available_supply`, function(x) x$toJSON())
        } else {
          CryptoStatObject[['available_supply']] <- jsonlite::toJSON(self$`available_supply`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`total_supply`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`total_supply`) && ((length(self$`total_supply`) == 0) || ((length(self$`total_supply`) != 0 && R6::is.R6(self$`total_supply`[[1]]))))) {
          CryptoStatObject[['total_supply']] <- lapply(self$`total_supply`, function(x) x$toJSON())
        } else {
          CryptoStatObject[['total_supply']] <- jsonlite::toJSON(self$`total_supply`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`max_supply`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`max_supply`) && ((length(self$`max_supply`) == 0) || ((length(self$`max_supply`) != 0 && R6::is.R6(self$`max_supply`[[1]]))))) {
          CryptoStatObject[['max_supply']] <- lapply(self$`max_supply`, function(x) x$toJSON())
        } else {
          CryptoStatObject[['max_supply']] <- jsonlite::toJSON(self$`max_supply`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`last_updated`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`last_updated`) && ((length(self$`last_updated`) == 0) || ((length(self$`last_updated`) != 0 && R6::is.R6(self$`last_updated`[[1]]))))) {
          CryptoStatObject[['last_updated']] <- lapply(self$`last_updated`, function(x) x$toJSON())
        } else {
          CryptoStatObject[['last_updated']] <- jsonlite::toJSON(self$`last_updated`, auto_unbox = TRUE)
        }
      }

      CryptoStatObject
    },
    fromJSON = function(CryptoStatJson) {
      CryptoStatObject <- jsonlite::fromJSON(CryptoStatJson)
      if (!is.null(CryptoStatObject$`name`)) {
        self$`name` <- CryptoStatObject$`name`
      }
      if (!is.null(CryptoStatObject$`code`)) {
        self$`code` <- CryptoStatObject$`code`
      }
      if (!is.null(CryptoStatObject$`symbol`)) {
        self$`symbol` <- CryptoStatObject$`symbol`
      }
      if (!is.null(CryptoStatObject$`market_cap_usd`)) {
        self$`market_cap_usd` <- CryptoStatObject$`market_cap_usd`
      }
      if (!is.null(CryptoStatObject$`available_supply`)) {
        self$`available_supply` <- CryptoStatObject$`available_supply`
      }
      if (!is.null(CryptoStatObject$`total_supply`)) {
        self$`total_supply` <- CryptoStatObject$`total_supply`
      }
      if (!is.null(CryptoStatObject$`max_supply`)) {
        self$`max_supply` <- CryptoStatObject$`max_supply`
      }
      if (!is.null(CryptoStatObject$`last_updated`)) {
        self$`last_updated` <- CryptoStatObject$`last_updated`
      }
    },
    toJSONString = function() {
      jsonlite::toJSON(self$toJSON(), auto_unbox = TRUE, pretty = TRUE)
    },
    fromJSONString = function(CryptoStatJson) {
      CryptoStatObject <- jsonlite::fromJSON(CryptoStatJson, simplifyDataFrame = FALSE)
      self$setFromList(CryptoStatObject)
    },
    setFromList = function(listObject) {
      if (!is.null(listObject$`name`)) {
        self$`name` <- listObject$`name`
      }
      else {
        self$`name` <- NA 
      }

      if (!is.null(listObject$`code`)) {
        self$`code` <- listObject$`code`
      }
      else {
        self$`code` <- NA 
      }

      if (!is.null(listObject$`symbol`)) {
        self$`symbol` <- listObject$`symbol`
      }
      else {
        self$`symbol` <- NA 
      }

      if (!is.null(listObject$`market_cap_usd`)) {
        self$`market_cap_usd` <- listObject$`market_cap_usd`
      }
      else {
        self$`market_cap_usd` <- NA 
      }

      if (!is.null(listObject$`available_supply`)) {
        self$`available_supply` <- listObject$`available_supply`
      }
      else {
        self$`available_supply` <- NA 
      }

      if (!is.null(listObject$`total_supply`)) {
        self$`total_supply` <- listObject$`total_supply`
      }
      else {
        self$`total_supply` <- NA 
      }

      if (!is.null(listObject$`max_supply`)) {
        self$`max_supply` <- listObject$`max_supply`
      }
      else {
        self$`max_supply` <- NA 
      }

      if (!is.null(listObject$`last_updated`)) {
        self$`last_updated` <- listObject$`last_updated`
      }
      else {
        self$`last_updated` <- NA 
      }

    },
    getAsList = function() {
      listObject = list()
      listObject[["name"]] <- self$`name`
      listObject[["code"]] <- self$`code`
      listObject[["symbol"]] <- self$`symbol`
      listObject[["market_cap_usd"]] <- self$`market_cap_usd`
      listObject[["available_supply"]] <- self$`available_supply`
      listObject[["total_supply"]] <- self$`total_supply`
      listObject[["max_supply"]] <- self$`max_supply`
      listObject[["last_updated"]] <- self$`last_updated`
      return(listObject)
    }
  )
)
